<template>
  <div>
    <b-container fluid>

      <h3>TODOs</h3>
      <b-row>
        <b-col md="6" offset-md="3" sm="12">
          <b-form-group>
            <b-form-input v-model="task.description" @keyup.enter="createTask" type="text" placeholder="O que precisa ser feito?" />
          </b-form-group>
        </b-col>
      </b-row>
      
      <br>

      <b-row>
        <b-col md="6" offset-md="3" sm="12">
          <b-form-radio-group v-model="state">
            <b-form-radio v-for="(state, index) in status" :key="index" :value="state.value">{{ state.text }}</b-form-radio>
          </b-form-radio-group>
        </b-col>
      </b-row>

      <br>

      <b-row>
        <b-col md="6" offset-md="3" sm="12">
          <b-list-group>
            <task v-for="(task, index) in getFilteredTasks" :key="task.id" :task="task" @remove="removeTask" @updateIsCompleted="updateIsCompleted" @changeOrder="changeOrder" :index="index + 1" :lastIndex="tasks.length"></task>
          </b-list-group>
        </b-col>

        <b-col md="6" offset-md="3" sm="12">
          <p class="text-left"><small>{{ remainingTasks }} tarefas restantes</small></p>
        </b-col>
      </b-row>

    </b-container>
  </div>
</template>

<script>

import Task from './Task'

export default {
  name: 'tasks',
  components: {
    Task
  },
  mounted() {
    this.getTasks();
  },
  data() {
    return {
      task: {
        id: '',
        order: '',
        completed: false,
        description: ''
      },
      tasks: [],
      status: [
        { text: 'Todos', value: 'todos' },
        { text: 'À fazer', value: 'afazer' },
        { text: 'Completos', value: 'completos' }
      ],
      state: 'todos'
    }
  },
  methods: {
    getTasks() {
      this.$emit('setPreloader', true);
      this.$http.get('todos?_sort=completed,order&_order=asc,asc')
        .then(response => {
          if (response.status === 200) {
            this.tasks = response.data;
          }
        })
        .catch(error => console.log(error.response))
        .finally(() => this.$emit('setPreloader', false));
    },
    createTask() {
      if (this.description !== '') {
        this.task.order = (this.tasks.length + 1);

        this.$emit('setPreloader', true);
        this.$http.post('todos', this.task)
          .then(response => {
            if (response.status === 201) {
              this.getTasks();
              this.clearTask();
            }
          })
          .catch(error => console.log(error.response))
          .finally(() => this.$emit('setPreloader', false));
      }
    },
    removeTask(id) {
      this.$emit('setPreloader', true);
      this.$http.delete('todos/' + id)
        .then(response => {
          if (response.status === 200) {
            this.getTasks();

            var _this = this;
            setTimeout(() => {
              _this.reorderTasks();
            }, 1000);
          }
        })
        .catch(error => console.log(error.response))
        .finally(() => this.$emit('setPreloader', false));
    },
    updateIsCompleted(task) {
      this.$emit('setPreloader', true);
      this.$http.put('todos/' + task.id, task)
        .then(response => {
          if (response.status === 200) {
            this.getTasks();
          }
        })
        .catch(error => console.log(error.response))
        .finally(() => this.$emit('setPreloader', false));
    },
    reorderTasks() {
      return this.tasks.map((task, index) => {
        task.order = (index + 1);
        this.$http.put('todos/' + task.id, task);
      });
    },
    changeOrder(currentOrder, targetIndex) {
      var currentTask = this.tasks.find(task => task.order == currentOrder);
      var otherTask = this.tasks[targetIndex];
      var targetOrder = otherTask.order;

      currentTask.order = targetOrder;
      this.$http.put('todos/' + currentTask.id, currentTask);
      otherTask.order = currentOrder;
      this.$http.put('todos/' + otherTask.id, otherTask);

      var _this = this;
      setTimeout(() => {
        _this.getTasks();
      }, 1000);
    },
    clearTask() {
      this.task = {
        id: '',
        order: '',
        completed: false,
        description: ''
      }
    }
  },
  computed: {
    remainingTasks() {
      if (this.state == 'completos') return 0
        
      return this.tasks.filter(task => {
        if (!task.completed) return task
      }).length;
    },
    getFilteredTasks() {
      return this.tasks.filter(task => {
        switch (this.state) {
          case 'afazer': 
            if (!task.completed) return task;
            break;
          case 'completos': 
            if (task.completed) return task;
            break;
          default: return task;
            break;
        }
      });
    }
  }
}
</script>

<style>
  h1, h2 {
    font-weight: normal;
  }
  ul {
    list-style-type: none;
    padding: 0;
  }
  li {
    display: inline-block;
    margin: 0 10px;
  }
  a {
    color: #42b983;
  }
</style>
